$(function () {
	var flippie, donebutton;
	
	// flip widget over
	function showBack() {
		widget.prepareForTransition('ToBack');
		document.getElementById('front').style.display = 'none';
		document.getElementById('back').style.display  = 'block';
		setTimeout(function () {
			widget.performTransition();
		}, 0);
	};
	
	// flip widget back
	function showFront() {
		widget.prepareForTransition('ToFront');
		document.getElementById('front').style.display = 'block';
		document.getElementById('back').style.display  = 'none';
		setTimeout(function () {
			widget.performTransition();
			start();
		}, 0);
	};
	
	flippie    = new AppleInfoButton(document.getElementById('flippie'), document.getElementById('front'), 'black', 'black', showBack);
	donebutton = new AppleGlassButton(document.getElementById('donebutton'), 'Done', showFront);
	
	$('#result button').click(function (evt) {
		var result;
		result = $('#result textarea').val();
		result = result.replace(/"/g, '\\\"'); // escape quotes
		result = result.replace(/\\\\\"/g, '\\\\\\"'); // escape escaped quotes
		widget.system('/bin/echo -n "' + result + '" | /usr/bin/pbcopy', function (obj) {});
	});
	
	$('form').submit(function (evt) {
		var form;
		
		form = $(this);
		
		function beforeSend() {
			$('#loader').css({
				display : 'inline-block'
			});
		}
		
		function success(response, status, xhr) {
			if ('object' === typeof response) {
				response = (new XMLSerializer()).serializeToString(response);
			}
			$('#result > textarea').val(response);
		}
		
		function error(xhr, status, error) {
			$('#error')
				.html('Status: ' + xhr.status)
				.fadeIn('fast')
				.click(function (evt) {
					$(this).fadeOut('fast');
				})
			;
		}
		
		function complete(xhr, status) {
			$('#loader').css({
				display : 'none'
			});
		}
		
		$.ajax({
			url         : form.attr('action'),
			type        : form.attr('method'),
			contentType : form.attr('enctype'),
			data        : form.serialize(),
			beforeSend  : beforeSend,
			success     : success,
			error       : error,
			complete    : complete
		});
		
		evt.preventDefault();
	});
	
});
